# spacetower_orbit_determination_python_client
Orbit Determination API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.6.0
- Package version: 1.6.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacetower_orbit_determination_python_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacetower_orbit_determination_python_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacetower_orbit_determination_python_client
from spacetower_orbit_determination_python_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://orbit-determination.exoops.57.128.40.142.sslip.io
# See configuration.py for a list of all supported configuration parameters.
configuration = spacetower_orbit_determination_python_client.Configuration(
    host = "http://orbit-determination.exoops.57.128.40.142.sslip.io"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: BearerAuth
configuration = spacetower_orbit_determination_python_client.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with spacetower_orbit_determination_python_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacetower_orbit_determination_python_client.DefaultApi(api_client)
    numerical_estimation_with_attitude_simulation_request = spacetower_orbit_determination_python_client.NumericalEstimationWithAttitudeSimulationRequest() # NumericalEstimationWithAttitudeSimulationRequest |  (optional)

    try:
        # Orbit determination with numerical propagation with attitude simulation
        api_response = api_instance.determine_orbit_with_attitude(numerical_estimation_with_attitude_simulation_request=numerical_estimation_with_attitude_simulation_request)
        print("The response of DefaultApi->determine_orbit_with_attitude:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->determine_orbit_with_attitude: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://orbit-determination.exoops.57.128.40.142.sslip.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**determine_orbit_with_attitude**](docs/DefaultApi.md#determine_orbit_with_attitude) | **POST** /estimation/numerical-with-attitude | Orbit determination with numerical propagation with attitude simulation
*DefaultApi* | [**determine_orbit_without_attitude**](docs/DefaultApi.md#determine_orbit_without_attitude) | **POST** /estimation/numerical-without-attitude | Orbit determination with numerical propagation without attitude simulation
*DefaultApi* | [**determine_tle**](docs/DefaultApi.md#determine_tle) | **POST** /estimation/tle | Orbit determination with SGP4 model
*DefaultApi* | [**residuals_numerical_with_attitude**](docs/DefaultApi.md#residuals_numerical_with_attitude) | **POST** /residuals/numerical-with-attitude | Residuals with numerical propagation including attitude simulation
*DefaultApi* | [**residuals_numerical_without_attitude**](docs/DefaultApi.md#residuals_numerical_without_attitude) | **POST** /residuals/numerical-without-attitude | Residuals with numerical propagation without attitude simulation
*DefaultApi* | [**residuals_tle**](docs/DefaultApi.md#residuals_tle) | **POST** /residuals/tle | Residuals with SGP4 model


## Documentation For Models

 - [AnomalyType](docs/AnomalyType.md)
 - [AprioriResidualsComputationRequest](docs/AprioriResidualsComputationRequest.md)
 - [AprioriResidualsComputationResult](docs/AprioriResidualsComputationResult.md)
 - [AtmosphereModel](docs/AtmosphereModel.md)
 - [AtmosphereType](docs/AtmosphereType.md)
 - [AtmosphericDragPerturbation](docs/AtmosphericDragPerturbation.md)
 - [AttitudeBasedFiniteThrustSchedule](docs/AttitudeBasedFiniteThrustSchedule.md)
 - [AttitudeLaw](docs/AttitudeLaw.md)
 - [AttitudeLawType](docs/AttitudeLawType.md)
 - [AttitudeSequence](docs/AttitudeSequence.md)
 - [AttitudeSequenceType](docs/AttitudeSequenceType.md)
 - [BatchLeastSquaresEstimationConfiguration](docs/BatchLeastSquaresEstimationConfiguration.md)
 - [BatchLeastSquaresMeasurementParametersEstimationRequest](docs/BatchLeastSquaresMeasurementParametersEstimationRequest.md)
 - [BatchLeastSquaresOrbitEstimationRequest](docs/BatchLeastSquaresOrbitEstimationRequest.md)
 - [BatchLeastSquaresPropagationParametersEstimationRequest](docs/BatchLeastSquaresPropagationParametersEstimationRequest.md)
 - [BatchResiduals](docs/BatchResiduals.md)
 - [BatchResult](docs/BatchResult.md)
 - [BoxObject](docs/BoxObject.md)
 - [BoxObjectStateEstimate](docs/BoxObjectStateEstimate.md)
 - [CartesianCovarianceFrameId](docs/CartesianCovarianceFrameId.md)
 - [CartesianCovarianceMatrix](docs/CartesianCovarianceMatrix.md)
 - [CartesianOrbit](docs/CartesianOrbit.md)
 - [CartesianProcessNoiseDiagonalMatrix](docs/CartesianProcessNoiseDiagonalMatrix.md)
 - [CircularOrbit](docs/CircularOrbit.md)
 - [ConstantNoiseProvider](docs/ConstantNoiseProvider.md)
 - [CovarianceOrbitType](docs/CovarianceOrbitType.md)
 - [DateTriggeredAttitude](docs/DateTriggeredAttitude.md)
 - [DateTriggeredAttitudeSequence](docs/DateTriggeredAttitudeSequence.md)
 - [DatedAprioriResiduals](docs/DatedAprioriResiduals.md)
 - [DatedCovarianceMatrix](docs/DatedCovarianceMatrix.md)
 - [DatedCovarianceMatrixSet](docs/DatedCovarianceMatrixSet.md)
 - [DatedEstimatedResiduals](docs/DatedEstimatedResiduals.md)
 - [DatedLocalFrameFiniteThrustDirection](docs/DatedLocalFrameFiniteThrustDirection.md)
 - [DeprecatedKalmanResult](docs/DeprecatedKalmanResult.md)
 - [EarthCenteredFrameId](docs/EarthCenteredFrameId.md)
 - [EarthFixedFrameId](docs/EarthFixedFrameId.md)
 - [EarthOrientedManeuverAttitudeLaw](docs/EarthOrientedManeuverAttitudeLaw.md)
 - [EarthPotentialPerturbation](docs/EarthPotentialPerturbation.md)
 - [EllipsoidId](docs/EllipsoidId.md)
 - [EquinoctialOrbit](docs/EquinoctialOrbit.md)
 - [EstimatedOrbitType](docs/EstimatedOrbitType.md)
 - [EstimationConfiguration](docs/EstimationConfiguration.md)
 - [EstimationResult](docs/EstimationResult.md)
 - [EstimatorType](docs/EstimatorType.md)
 - [ExtendedKalmanFilterConfiguration](docs/ExtendedKalmanFilterConfiguration.md)
 - [ExtendedKalmanFilterEstimationConfiguration](docs/ExtendedKalmanFilterEstimationConfiguration.md)
 - [FieldDescription](docs/FieldDescription.md)
 - [FiniteThrustDefinition](docs/FiniteThrustDefinition.md)
 - [FixedStepIntegratorConfiguration](docs/FixedStepIntegratorConfiguration.md)
 - [FixedStepIntegratorType](docs/FixedStepIntegratorType.md)
 - [GpsNmeaMeasurements](docs/GpsNmeaMeasurements.md)
 - [HarrisPriesterAtmosphere](docs/HarrisPriesterAtmosphere.md)
 - [InertialFrameId](docs/InertialFrameId.md)
 - [IntegratorConfiguration](docs/IntegratorConfiguration.md)
 - [IntegratorType](docs/IntegratorType.md)
 - [InterpolatedLocalFrameAttitudeLaw](docs/InterpolatedLocalFrameAttitudeLaw.md)
 - [IsotropicObject](docs/IsotropicObject.md)
 - [IsotropicObjectStateEstimate](docs/IsotropicObjectStateEstimate.md)
 - [KalmanDragCoefficientEstimationRequest](docs/KalmanDragCoefficientEstimationRequest.md)
 - [KalmanFilterEstimationConfigurationCommons](docs/KalmanFilterEstimationConfigurationCommons.md)
 - [KalmanOrbitEstimationRequest](docs/KalmanOrbitEstimationRequest.md)
 - [KalmanReflectivityCoefficientEstimationRequest](docs/KalmanReflectivityCoefficientEstimationRequest.md)
 - [KalmanResiduals](docs/KalmanResiduals.md)
 - [KalmanResult](docs/KalmanResult.md)
 - [KalmanSatelliteClockOffsetEstimationRequest](docs/KalmanSatelliteClockOffsetEstimationRequest.md)
 - [KalmanThrustScaleFactorsEstimationRequest](docs/KalmanThrustScaleFactorsEstimationRequest.md)
 - [KeplerianOrbit](docs/KeplerianOrbit.md)
 - [LeastSquaresConfiguration](docs/LeastSquaresConfiguration.md)
 - [LeastSquaresOptimizerType](docs/LeastSquaresOptimizerType.md)
 - [LocalFrameAttitudeLaw](docs/LocalFrameAttitudeLaw.md)
 - [LocalFrameBasedFiniteThrustSequence](docs/LocalFrameBasedFiniteThrustSequence.md)
 - [LocalFrameBasedManeuverSchedule](docs/LocalFrameBasedManeuverSchedule.md)
 - [ManeuverDirectionType](docs/ManeuverDirectionType.md)
 - [ManeuverSchedule](docs/ManeuverSchedule.md)
 - [ManeuverScheduleType](docs/ManeuverScheduleType.md)
 - [MeanOsculatingOrbitType](docs/MeanOsculatingOrbitType.md)
 - [MeasurementType](docs/MeasurementType.md)
 - [Measurements](docs/Measurements.md)
 - [NadirPointingLaw](docs/NadirPointingLaw.md)
 - [NrlMsise00Atmosphere](docs/NrlMsise00Atmosphere.md)
 - [NumericalAprioriResidualsComputationRequestCommonFields](docs/NumericalAprioriResidualsComputationRequestCommonFields.md)
 - [NumericalAprioriResidualsComputationResult](docs/NumericalAprioriResidualsComputationResult.md)
 - [NumericalAprioriResidualsComputationWithAttitudeSimulationRequest](docs/NumericalAprioriResidualsComputationWithAttitudeSimulationRequest.md)
 - [NumericalAprioriResidualsComputationWithoutAttitudeSimulationRequest](docs/NumericalAprioriResidualsComputationWithoutAttitudeSimulationRequest.md)
 - [NumericalEstimationWithAttitudeSimulationRequest](docs/NumericalEstimationWithAttitudeSimulationRequest.md)
 - [NumericalEstimationWithAttitudeSimulationResult](docs/NumericalEstimationWithAttitudeSimulationResult.md)
 - [NumericalEstimationWithoutAttitudeSimulationRequest](docs/NumericalEstimationWithoutAttitudeSimulationRequest.md)
 - [NumericalEstimationWithoutAttitudeSimulationResult](docs/NumericalEstimationWithoutAttitudeSimulationResult.md)
 - [Orbit](docs/Orbit.md)
 - [OrbitEstimationRequestCommonFields](docs/OrbitEstimationRequestCommonFields.md)
 - [OrbitType](docs/OrbitType.md)
 - [OrbitalCovarianceMatrix](docs/OrbitalCovarianceMatrix.md)
 - [OrbitalElementsCovarianceMatrix](docs/OrbitalElementsCovarianceMatrix.md)
 - [OrbitalProcessNoiseProvider](docs/OrbitalProcessNoiseProvider.md)
 - [OrbitalProcessNoiseProviderType](docs/OrbitalProcessNoiseProviderType.md)
 - [OsculatingToMeanConversionTheory](docs/OsculatingToMeanConversionTheory.md)
 - [OutputCovarianceConfiguration](docs/OutputCovarianceConfiguration.md)
 - [OutputModelParameters](docs/OutputModelParameters.md)
 - [Perturbation](docs/Perturbation.md)
 - [PerturbationType](docs/PerturbationType.md)
 - [PositionMeasurements](docs/PositionMeasurements.md)
 - [PositionVelocityMeasurements](docs/PositionVelocityMeasurements.md)
 - [PostProcessConfiguration](docs/PostProcessConfiguration.md)
 - [PropulsionSystem](docs/PropulsionSystem.md)
 - [RadiationCoefficients](docs/RadiationCoefficients.md)
 - [RadiationCoefficientsType](docs/RadiationCoefficientsType.md)
 - [ReflectionAbsorptionCoefficients](docs/ReflectionAbsorptionCoefficients.md)
 - [ResidualComputationConfiguration](docs/ResidualComputationConfiguration.md)
 - [Residuals](docs/Residuals.md)
 - [RotatingLocalFrameId](docs/RotatingLocalFrameId.md)
 - [RotationConvention](docs/RotationConvention.md)
 - [RotationOrder](docs/RotationOrder.md)
 - [SatelliteClockOffsetEstimationRequest](docs/SatelliteClockOffsetEstimationRequest.md)
 - [ShadowModelType](docs/ShadowModelType.md)
 - [SimpleKalmanModelParameterEstimationRequest](docs/SimpleKalmanModelParameterEstimationRequest.md)
 - [SimulationConfiguration](docs/SimulationConfiguration.md)
 - [SingleRadiationCoefficient](docs/SingleRadiationCoefficient.md)
 - [SolarArrayGeometry](docs/SolarArrayGeometry.md)
 - [SolarRadiationPressurePerturbation](docs/SolarRadiationPressurePerturbation.md)
 - [SolidTidesPerturbation](docs/SolidTidesPerturbation.md)
 - [SpaceObject](docs/SpaceObject.md)
 - [SpaceObjectType](docs/SpaceObjectType.md)
 - [SpectralDensityMatrix](docs/SpectralDensityMatrix.md)
 - [StateNoiseCompensationProvider](docs/StateNoiseCompensationProvider.md)
 - [StaticOutlierFilter](docs/StaticOutlierFilter.md)
 - [SunEnhancedManeuverAttitudeLaw](docs/SunEnhancedManeuverAttitudeLaw.md)
 - [SunPointingLaw](docs/SunPointingLaw.md)
 - [TLE](docs/TLE.md)
 - [ThirdBodiesGravityPerturbation](docs/ThirdBodiesGravityPerturbation.md)
 - [ThirdBodyName](docs/ThirdBodyName.md)
 - [Thruster](docs/Thruster.md)
 - [TimeLinearNoiseProvider](docs/TimeLinearNoiseProvider.md)
 - [TleAprioriResidualsComputationRequest](docs/TleAprioriResidualsComputationRequest.md)
 - [TleAprioriResidualsComputationResult](docs/TleAprioriResidualsComputationResult.md)
 - [TleEstimationRequest](docs/TleEstimationRequest.md)
 - [TleEstimationResult](docs/TleEstimationResult.md)
 - [TwoLineElementOrbit](docs/TwoLineElementOrbit.md)
 - [UncertaintyEstimate](docs/UncertaintyEstimate.md)
 - [UnscentedKalmanFilterConfiguration](docs/UnscentedKalmanFilterConfiguration.md)
 - [UnscentedKalmanFilterEstimationConfiguration](docs/UnscentedKalmanFilterEstimationConfiguration.md)
 - [UnscentedTransformConfiguration](docs/UnscentedTransformConfiguration.md)
 - [VariableStepIntegratorConfiguration](docs/VariableStepIntegratorConfiguration.md)
 - [VariableStepIntegratorType](docs/VariableStepIntegratorType.md)
 - [Vector3D](docs/Vector3D.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication


## Author




