# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from spacetower_orbit_determination_python_client.models.attitude_law import AttitudeLaw
from spacetower_orbit_determination_python_client.models.attitude_law_type import AttitudeLawType
from spacetower_orbit_determination_python_client.models.maneuver_direction_type import ManeuverDirectionType
from spacetower_orbit_determination_python_client.models.vector3_d import Vector3D
from typing import Optional, Set
from typing_extensions import Self

class EarthOrientedManeuverAttitudeLaw(AttitudeLaw):
    """
    Aligns the thruster axis to a given maneuver direction, expressed in a local orbital frame  (applies to BoxObject with a propulsion system only). A rotation around the thruster axis is computed in order to have a user-defined axis oriented towards the Earth as much as possible. 
    """ # noqa: E501
    earth_oriented_axis_in_space_object_frame: Vector3D = Field(description="3D vector in the space object frame that should be oriented towards the Earth. The input will automatically be normalised. ", alias="earthOrientedAxisInSpaceObjectFrame")
    maneuver_direction_type: ManeuverDirectionType = Field(alias="maneuverDirectionType")
    __properties: ClassVar[List[str]] = ["attitudeLawType", "earthOrientedAxisInSpaceObjectFrame", "maneuverDirectionType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EarthOrientedManeuverAttitudeLaw from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of earth_oriented_axis_in_space_object_frame
        if self.earth_oriented_axis_in_space_object_frame:
            _dict['earthOrientedAxisInSpaceObjectFrame'] = self.earth_oriented_axis_in_space_object_frame.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EarthOrientedManeuverAttitudeLaw from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attitudeLawType": obj.get("attitudeLawType"),
            "earthOrientedAxisInSpaceObjectFrame": Vector3D.from_dict(obj["earthOrientedAxisInSpaceObjectFrame"]) if obj.get("earthOrientedAxisInSpaceObjectFrame") is not None else None,
            "maneuverDirectionType": obj.get("maneuverDirectionType")
        })
        return _obj


