# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class EstimatorType(str, Enum):
    """
    Type of estimator. The (non-linear) least squares is a batch one, whilst Kalman filters are sequential in nature and can include process noise modelling. The difference between the extended and the unscented versions lie in the way covariance matrices are propagated: the latter uses a first-order Taylor series and the former an unscented transform (based on so-called sigma points). 
    """

    """
    allowed enum values
    """
    UNSCENTED_KALMAN = 'UNSCENTED_KALMAN'
    EXTENDED_KALMAN = 'EXTENDED_KALMAN'
    BATCH_LEAST_SQUARES = 'BATCH_LEAST_SQUARES'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EstimatorType from a JSON string"""
        return cls(json.loads(json_str))


