# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class InertialFrameId(str, Enum):
    """
    Inertial frame of reference. <br> - ```CIRF```: Celestial Intermediate Reference Frame. this is a quasi-inertial Earth-centred system. - ```EME2000```: Earth Mean Equator and Equinox at epoch J2000. The J2000 frame is realized by the transformational algorithm between it and the Earth Fixed frame. - ```GCRF```: Geocentric Celestial Reference Frame. It is a standard inertial coordinate system for the Earth, with origin at the geocenter. - ```TEME```: The True Equator Mean Equinox frame does not have a universal definition  across references and software and should not be used, except when dealing with the so-called SGP4 orbital  theory (with TLE or the underlying averaged Keplerian elements) 
    """

    """
    allowed enum values
    """
    CIRF = 'CIRF'
    EME2000 = 'EME2000'
    GCRF = 'GCRF'
    TEME = 'TEME'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of InertialFrameId from a JSON string"""
        return cls(json.loads(json_str))


