# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_orbit_determination_python_client.models.deprecated_kalman_result import DeprecatedKalmanResult
from spacetower_orbit_determination_python_client.models.estimation_result import EstimationResult
from spacetower_orbit_determination_python_client.models.isotropic_object_state_estimate import IsotropicObjectStateEstimate
from typing import Optional, Set
from typing_extensions import Self

class NumericalEstimationWithoutAttitudeSimulationResult(BaseModel):
    """
    Output containing the estimated result for an isotropic object
    """ # noqa: E501
    state_estimate: IsotropicObjectStateEstimate = Field(alias="stateEstimate")
    kalman_result: Optional[DeprecatedKalmanResult] = Field(default=None, alias="kalmanResult")
    estimation_result: Optional[EstimationResult] = Field(default=None, alias="estimationResult")
    data: Optional[Dict[str, StrictStr]] = Field(default=None, description="References to the data used during the computation")
    __properties: ClassVar[List[str]] = ["stateEstimate", "kalmanResult", "estimationResult", "data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NumericalEstimationWithoutAttitudeSimulationResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of state_estimate
        if self.state_estimate:
            _dict['stateEstimate'] = self.state_estimate.to_dict()
        # override the default output from pydantic by calling `to_dict()` of kalman_result
        if self.kalman_result:
            _dict['kalmanResult'] = self.kalman_result.to_dict()
        # override the default output from pydantic by calling `to_dict()` of estimation_result
        if self.estimation_result:
            _dict['estimationResult'] = self.estimation_result.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NumericalEstimationWithoutAttitudeSimulationResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "stateEstimate": IsotropicObjectStateEstimate.from_dict(obj["stateEstimate"]) if obj.get("stateEstimate") is not None else None,
            "kalmanResult": DeprecatedKalmanResult.from_dict(obj["kalmanResult"]) if obj.get("kalmanResult") is not None else None,
            "estimationResult": EstimationResult.from_dict(obj["estimationResult"]) if obj.get("estimationResult") is not None else None,
            "data": obj.get("data")
        })
        return _obj


