# coding: utf-8

"""
    Orbit Determination API

    Orbit Determination API

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_orbit_determination_python_client.models.batch_residuals import BatchResiduals
from spacetower_orbit_determination_python_client.models.two_line_element_orbit import TwoLineElementOrbit
from typing import Optional, Set
from typing_extensions import Self

class TleEstimationResult(BaseModel):
    """
    Output containing the estimated Two Line Element and batch residuals
    """ # noqa: E501
    estimated_tle: Optional[TwoLineElementOrbit] = Field(default=None, alias="estimatedTle")
    batch_residuals: Optional[BatchResiduals] = Field(default=None, alias="batchResiduals")
    data: Optional[Dict[str, StrictStr]] = Field(default=None, description="References to the data used during the computation")
    __properties: ClassVar[List[str]] = ["estimatedTle", "batchResiduals", "data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TleEstimationResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of estimated_tle
        if self.estimated_tle:
            _dict['estimatedTle'] = self.estimated_tle.to_dict()
        # override the default output from pydantic by calling `to_dict()` of batch_residuals
        if self.batch_residuals:
            _dict['batchResiduals'] = self.batch_residuals.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TleEstimationResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "estimatedTle": TwoLineElementOrbit.from_dict(obj["estimatedTle"]) if obj.get("estimatedTle") is not None else None,
            "batchResiduals": BatchResiduals.from_dict(obj["batchResiduals"]) if obj.get("batchResiduals") is not None else None,
            "data": obj.get("data")
        })
        return _obj


